<template>
    <div class="card border-left-success shadow mb-4">
        <div
            class="card-header bg-white py-3 d-flex flex-row align-items-center justify-content-between"
        >
            <h6 class="m-0 font-weight-bold text-primary text-capitalize">
                <router-link
                    :event="disabled ? '' : 'click'"
                    :to="{
                        name: 'ProjectShow',
                        params: { id: dataProject.id }
                    }"
                    >{{ dataProject.name }}</router-link
                >
            </h6>
            <div
                class="dropdown no-arrow"
                v-show="!disabled || editable || deletable"
            >
                <a
                    class="dropdown-toggle"
                    href="#"
                    role="button"
                    id="dropdownMenuLink"
                    data-toggle="dropdown"
                    aria-haspopup="true"
                    aria-expanded="false"
                >
                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                </a>
                <div
                    class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
                    aria-labelledby="dropdownMenuLink"
                >
                    <router-link
                        class="dropdown-item text-warning"
                        v-show="!disabled || editable"
                        :to="{
                            name: 'ProjectEdit',
                            params: { id: dataProject.id }
                        }"
                        >Edit</router-link
                    >
                    <a class="dropdown-item text-success" href="#"
                        >Mark it Done</a
                    >
                    <a
                        class="dropdown-item text-danger"
                        v-show="!disabled || deletable"
                        @click="onDelete"
                        >Delete</a
                    >
                </div>
            </div>
        </div>
        <div class="card-body px-5">
            <div class="row align-items-center text-right">
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Location</div>
                    <div class="h5 mb-0 text-gray-800 text-capitalize">
                        {{ dataProject.location ? dataProject.location : "NA" }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Install At</div>
                    <div class="h5 mb-0 text-gray-800">
                        {{
                            dataProject.installed_at
                                ? dataProject.installed_at
                                : "NA"
                        }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Dismantle At</div>
                    <div class="h5 mb-0 text-gray-800">
                        {{
                            dataProject.dismantle_at
                                ? dataProject.dismantle_at
                                : "NA"
                        }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Owner</div>
                    <div class="h5 mb-0 text-gray-800">
                        {{
                            dataProject.owner
                                ? dataProject.owner.full_name
                                : "NA"
                        }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Status</div>
                    <div class="h5 mb-0 text-gray-800">
                        {{ dataProject.status ? dataProject.status : "NA" }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 text-center">
                    <button
                        @click="onFollow()"
                        class="btn btn-primary btn-block"
                        :disabled="isOwned || isDisabledButton"
                    >
                        {{ isOwned || isFollowed ? "FOLLOWED" : "FOLLOW" }}
                    </button>
                </div>
            </div>
        </div>
        <div class="card-footer bg-white">
            <progress-bar :percentage="dataProject.percentage"></progress-bar>
        </div>
    </div>
</template>

<script>
import ProgressBar from "../ProgressBarComponent";
import Swal from "sweetalert2";
export default {
    components: {
        ProgressBar
    },
    props: ["project", "disabled", "deletable", "editable"],
    data() {
        return {
            dataProject: this.project,
            isDisabledButton: false
        };
    },
    methods: {
        onFollow() {
            if (this.isDisabledButton) {
                return;
            }

            this.isDisabledButton = true;

            if (this.isFollowed) {
                axios
                    .get("/api/project/" + this.dataProject.id + "/unfollow")
                    .then(res => {
                        this.dataProject.employees = [];
                    })
                    .catch(err => {
                        console.log(err.message);
                    })
                    .then(res => {
                        this.isDisabledButton = false;
                    });
            } else {
                axios
                    .get("/api/project/" + this.dataProject.id + "/follow")
                    .then(res => {
                        this.dataProject.employees.push({
                            id: res.data
                        });
                    })
                    .catch(err => {
                        console.log(err.message);
                    })
                    .then(res => {
                        this.isDisabledButton = false;
                    });
            }
        },
        onDelete() {
            Swal.fire({
                title: "Are you sure?",
                text: "You won't be able to revert this!",
                icon: "warning",
                showCancelButton: true,
                confirmButtonColor: "#3085d6",
                cancelButtonColor: "#d33",
                confirmButtonText: "Yes, delete it!"
            }).then(result => {
                if (result.isConfirmed) {
                    axios
                        .delete("/project/" + this.dataProject.id)
                        .then(res => {
                            Swal.fire("Deleted!", "", "success").then(
                                result => {
                                    this.$emit("delete");

                                    if (this.$route.name == "ProjectShow") {
                                        this.$router.push({
                                            name: "ProjectIndex"
                                        });
                                    }
                                }
                            );
                        })
                        .catch(err => {
                            console.warn(err);
                            Swal.fire("Error!", err.message, "error");
                        });
                }
            });
        }
    },
    computed: {
        isFollowed() {
            return _.find(
                this.dataProject.employees,
                function(o) {
                    return o.id == this.$userId;
                }.bind(this)
            );
        },
        isOwned() {
            return this.dataProject.owner_id == this.$userId;
        }
    }
};
</script>
